/*
AndroidDisplay.cpp
Copyright (c) 2016 Sergio Daniel Castañeda N.

*/


#include "AndroidDisplay.h"


using namespace std;


void AndroidDisplay::printo(String toPrint){
  mySerial->println(toPrint);
}

void AndroidDisplay::setSerial(HardwareSerial &tempSerial){
  mySerial = &tempSerial;
  //mySerial->setTimeOut(100);
  resetDisplay();
}


void AndroidDisplay::fragmentData(uint32_t tempInt32, uint8_t basura){
  ld = (tempInt32 & (LDMASK));

  tempValue32 = (tempInt32 & (MDMASK));
  md = (tempValue32 >> 6);

  tempValue32 = (tempInt32 & (HDMASKLDMASK32));
  hd = (tempValue32 >> 12);

  tempValue32 = (tempInt32 & (LDMASK32));
  ld32 = (tempValue32 >>18);

  tempValue32 = (tempInt32 & (MDMASK32));
  md32 = (tempValue32 >> 24);

  tempValue32 =(tempInt32 & (HDMASK32));
  hd32 = (tempValue32 >> 30);

}

void AndroidDisplay::fragmentData(uint16_t tempInt16){
  ld = (tempInt16 & (LDMASK));

  tempValue = (tempInt16 & (MDMASK));
  md = (tempValue >> 6);

  tempValue = (tempInt16 & (HDMASK));
  hd = (tempValue >> 12);
}


void AndroidDisplay::fragmentData(uint16_t tempInt16, boolean bol){
  ld = (tempInt16 & (LDMASK));

  tempValue = (tempInt16 & (MDMASK));
  md = (tempValue >> 6);
}

uint16_t AndroidDisplay::color565(uint8_t r, uint8_t g, uint8_t b){
  return ((r & 0xF8) << 8) | ((g & 0xFC) << 3) | (b >> 3); 
}


void AndroidDisplay::fillScreen(uint16_t colorf){
  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

    mySerial->write(97); //65

    mySerial->write(1);

    fragmentData(colorf);

    mySerial->write(hd);
    mySerial->write(md);
    mySerial->write(ld);
    mySerial->write(98);     //Delimitador 64

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }

  }


}



void AndroidDisplay::drawPixel(int16_t x, int16_t y, uint16_t color){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){


  mySerial->write(97);
  mySerial->write(2);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }

  }


}

/*
void AndroidDisplay::drawPixel(int16_t x, int16_t y, uint16_t color){

  checked = 0;
  txNotCompleted = true;


  mySerial->write(100);
  mySerial->write(2);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(99);


}*/

void AndroidDisplay::drawLine(int16_t x0, int16_t y0, int16_t x1, int16_t y1, uint16_t color){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){


  mySerial->write(97);
  mySerial->write(3);

  fragmentData(x0);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y0);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(x1);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y1);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }

  }

}

void AndroidDisplay::drawLineByAngle(int16_t x, int16_t y, int16_t angle, uint16_t length, uint16_t color){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(4);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(angle);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(length);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }

  }

}


void AndroidDisplay::drawLineByAngle(int16_t x, int16_t y, int16_t angle, uint16_t start, uint16_t length, uint16_t color){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(5);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(angle);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(start);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(length);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }

  }

}

void AndroidDisplay::drawFastHLine(int16_t x, int16_t y, uint16_t w, uint16_t color){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(6);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(w);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }

  }

}

void AndroidDisplay::drawFastVLine(int16_t x, int16_t y, uint16_t h, uint16_t color){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(7);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(h);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }

  }
}

void AndroidDisplay::drawRect(int16_t x, int16_t y, int16_t w, int16_t h, uint16_t color){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(8);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(w);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(h);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }

  }
}

void AndroidDisplay::fillRect(int16_t x, int16_t y, int16_t w, int16_t h, uint16_t color){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(9);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(w);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(h);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }

  }

}

void AndroidDisplay::drawRoundRect(int16_t x, int16_t y, int16_t w, int16_t h, int16_t radius, uint16_t color){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(10);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(w);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(h);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(radius);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }

  }
}

void AndroidDisplay::fillRoundRect(int16_t x, int16_t y, int16_t w, int16_t h, int16_t radius, uint16_t color){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(11);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(w);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(h);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(radius);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }

  }
}

void AndroidDisplay::drawCircle(int16_t x, int16_t y, int16_t r, uint16_t color){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(12);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(r);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);
    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }

  }

}

void AndroidDisplay::fillCircle(int16_t x, int16_t y, int16_t r, uint16_t color){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(13);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(r);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }

  }

}

void AndroidDisplay::fillArc(uint16_t x, uint16_t y, uint16_t radius, uint16_t thickness, float start, float end, uint16_t color){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(14);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(radius);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(thickness);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(10*start);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(10*end);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }

  }
}

void AndroidDisplay::drawTriangle(int16_t x0, int16_t y0, int16_t x1, int16_t y1, int16_t x2, int16_t y2, uint16_t color){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(15);

  fragmentData(x0);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y0);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(x1);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y1);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(x2);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y2);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }

  }

}

void AndroidDisplay::fillTriangle(int16_t x0, int16_t y0, int16_t x1, int16_t y1, int16_t x2, int16_t y2, uint16_t color){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(16);

  fragmentData(x0);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y0);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(x1);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y1);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(x2);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y2);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }

  }
}

void AndroidDisplay::drawBitmap(const uint8_t *bitmap, int16_t x, int16_t y, int16_t w, int16_t h, uint16_t color){
  boolean oneMore = false;
  checked = 0;
  txNotCompleted = true;
  bigDataInProgress = false;

  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(17);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(w);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(h);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  w = (w/8);// (w/8)

  float tempLimit = (w * h);
  uint8_t preData = 0;

  float tempPaquetes = (tempLimit / 500);
  int paquetes = round(tempPaquetes);
  float diferencia = 0;

  int ultimoPaquete = 0;


    if(paquetes > tempPaquetes){

      oneMore = true;
      paquetes -= 1;
      diferencia = tempPaquetes - paquetes;
      ultimoPaquete = (diferencia * 500);
    }

    else if(paquetes < tempPaquetes){

      oneMore = true;
      diferencia = tempPaquetes - paquetes;
      ultimoPaquete = (diferencia * 500);
    }


  int currentPackage = 0;

    if(tempPaquetes > 1){
      for(int i = 0; i<500; i++){
        preData = pgm_read_byte(bitmap + (i));
        fragmentData(preData, false);

        mySerial->write(md);
        mySerial->write(ld);
        currentPackage = 1;
      }

    }

    else{
      for(int i = 0; i<tempLimit; i++){
        preData = pgm_read_byte(bitmap + i);
        fragmentData(preData, false);
        mySerial->write(md);
        mySerial->write(ld);
      }
    }



  mySerial->write(98);

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }

      else if(bufferSerial[0] == 'g'){
        boolean notFinished = true;
        boolean waitingData = true;

        if((paquetes) != currentPackage){


        for(int i = currentPackage; i<paquetes; i++){
          mySerial->write(97);
          mySerial->write(17);

          if((oneMore == false) && (i == (paquetes-1))){
            mySerial->write('i');//6=normal 9=finished
          }

          else{
            mySerial->write('h');//6=normal 9=finished
          }


          int tempJ = (i*500);

          for(int j=0; j<500; j++) {
            preData = pgm_read_byte(bitmap + (j + tempJ));
            fragmentData(preData, false);

            mySerial->write(md);
            mySerial->write(ld);

          }

          mySerial->write(98);

          waitingData = true;

          while(waitingData){
            checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

            if(checked>0){
              if(bufferSerial[0] == 'g'){
                waitingData = false;
              }

              else if(bufferSerial[0] == 'c'){
                waitingData = false;
                txNotCompleted = false;
              }
            }

          }//END while waitingData
        }//END for

        }//END if((paquetes-1) == currentPackage)

        if(oneMore){

          mySerial->write(97);
          mySerial->write(17);
          mySerial->write('i');//h=normal i=finished


          for(int i=0; i<ultimoPaquete; i++) {
            preData = pgm_read_byte(bitmap + (i + (paquetes*500)));
            fragmentData(preData, false);

            mySerial->write(md);
            mySerial->write(ld);

          }

          mySerial->write(98);

        }//END if oneMore

        waitingData = true;
        while(waitingData){
            checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

            if(checked>0){
              if(bufferSerial[0] == 'c'){
                waitingData = false;
                txNotCompleted = false;
              }


            }

          }//END while waitingData


        //txNotCompleted = false;

      }//END else if 'g'

    }//END if checked
  }//END whiles txNotCompleted

}

void AndroidDisplay::drawBitmap(const uint8_t *bitmap, int16_t x, int16_t y, int16_t w, int16_t h, uint16_t color, uint16_t bgcolor){
  boolean oneMore = false;
  checked = 0;
  txNotCompleted = true;
  bigDataInProgress = false;

  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(18);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(w);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(h);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(bgcolor);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  w = (w/8);// (w/8)

  float tempLimit = (w * h);
  uint8_t preData = 0;

  float tempPaquetes = (tempLimit / 500);
  int paquetes = round(tempPaquetes);
  float diferencia = 0;

  int ultimoPaquete = 0;


    if(paquetes > tempPaquetes){

      oneMore = true;
      paquetes -= 1;
      diferencia = tempPaquetes - paquetes;
      ultimoPaquete = (diferencia * 500);
    }

    else if(paquetes < tempPaquetes){

      oneMore = true;
      diferencia = tempPaquetes - paquetes;
      ultimoPaquete = (diferencia * 500);
    }


  int currentPackage = 0;

    if(tempPaquetes > 1){
      for(int i = 0; i<500; i++){
        preData = pgm_read_byte(bitmap + (i));
        fragmentData(preData, false);

        mySerial->write(md);
        mySerial->write(ld);
        currentPackage = 1;
      }

    }

    else{
      for(int i = 0; i<tempLimit; i++){
        preData = pgm_read_byte(bitmap + i);
        fragmentData(preData, false);
        mySerial->write(md);
        mySerial->write(ld);
      }
    }



  mySerial->write(98);

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }

      else if(bufferSerial[0] == 'g'){
        boolean notFinished = true;
        boolean waitingData = true;

        if((paquetes) != currentPackage){


        for(int i = currentPackage; i<paquetes; i++){
          mySerial->write(97);
          mySerial->write(18);

          if((oneMore == false) && (i == (paquetes-1))){
            mySerial->write('i');//6=normal 9=finished
          }

          else{
            mySerial->write('h');//6=normal 9=finished
          }


          int tempJ = (i*500);

          for(int j=0; j<500; j++) {
            preData = pgm_read_byte(bitmap + (j + tempJ));
            fragmentData(preData, false);

            mySerial->write(md);
            mySerial->write(ld);

          }

          mySerial->write(98);

          waitingData = true;

          while(waitingData){
            checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

            if(checked>0){
              if(bufferSerial[0] == 'g'){
                waitingData = false;
              }

              else if(bufferSerial[0] == 'c'){
                waitingData = false;
                txNotCompleted = false;
              }
            }

          }//END while waitingData
        }//END for

        }//END if((paquetes-1) == currentPackage)

        if(oneMore){

          mySerial->write(97);
          mySerial->write(18);
          mySerial->write('i');//h=normal i=finished


          for(int i=0; i<ultimoPaquete; i++) {
            preData = pgm_read_byte(bitmap + (i + (paquetes*500)));
            fragmentData(preData, false);

            mySerial->write(md);
            mySerial->write(ld);

          }

          mySerial->write(98);

        }//END if oneMore

        waitingData = true;
        while(waitingData){
            checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

            if(checked>0){
              if(bufferSerial[0] == 'c'){
                waitingData = false;
                txNotCompleted = false;
              }


            }

          }//END while waitingData


        //txNotCompleted = false;

      }//END else if 'g'

    }//END if checked
  }//END whiles txNotCompleted

}


void AndroidDisplay::drawImage(const uint16_t *colors, uint16_t x, uint16_t y, uint16_t w, uint16_t h){

  boolean oneMore = false;
  checked = 0;
  txNotCompleted = true;
  bigDataInProgress = false;

  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(19);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(w);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(h);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  float tempLimit = (w * h);
  uint16_t preData = 0;

  float tempPaquetes = (tempLimit / 500);
  int paquetes = round(tempPaquetes);
  float diferencia = 0;

  int ultimoPaquete = 0;


    if(paquetes > tempPaquetes){

      oneMore = true;
      paquetes -= 1;
      diferencia = tempPaquetes - paquetes;//paquetes - tempPaquetes;
      ultimoPaquete = (diferencia * 500);
    }

    else if(paquetes < tempPaquetes){

      oneMore = true;
      diferencia = tempPaquetes - paquetes;
      ultimoPaquete = (diferencia * 500);
    }


  int currentPackage = 0;

    if(tempPaquetes > 1){
      for(int i = 0; i<500; i++){
         preData = pgm_read_word(colors + (i));
         fragmentData(preData);

        mySerial->write(hd);
        mySerial->write(md);
        mySerial->write(ld);
        currentPackage = 1;
      }

    }

    else{
      for(int i = 0; i<tempLimit; i++){
         preData = pgm_read_word(colors + (i));
         fragmentData(preData);

        mySerial->write(hd);
        mySerial->write(md);
        mySerial->write(ld);
      }
    }



   /*
  for(int i = 0; i<tempLimit; i++){
     preData = pgm_read_word(colors + i);
    fragmentData(preData);

    mySerial->write(hd);
    mySerial->write(md);
    mySerial->write(ld);
  }
  */
  mySerial->write(98);

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }

      else if(bufferSerial[0] == 'g'){
        boolean notFinished = true;
        boolean waitingData = true;

        for(int i = currentPackage; i<paquetes; i++){
          mySerial->write(97);
          mySerial->write(19);

          if((oneMore == false) && (i == (paquetes-1))){
            mySerial->write('i');//6=normal 9=finished
          }

          else{
            mySerial->write('h');//6=normal 9=finished
          }

          //mySerial->write(6);//6=normal 9=finished
          int tempJ = (i*500);

          for(int j=0; j<500; j++) {
            preData = pgm_read_word(colors + (j + tempJ));
            fragmentData(preData);

            mySerial->write(hd);
            mySerial->write(md);
            mySerial->write(ld);

          }

          mySerial->write(98);

          waitingData = true;

          while(waitingData){
            checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

            if(checked>0){
              if(bufferSerial[0] == 'g'){
                waitingData = false;
              }

              else if(bufferSerial[0] == 'c'){
                waitingData = false;
                txNotCompleted = false;
              }
            }

          }//END while waitingData
        }//END for

        if(oneMore){

          mySerial->write(97);
          mySerial->write(19);
          mySerial->write('i');//h=normal i=finished


          for(int i=0; i<ultimoPaquete; i++) {
            preData = pgm_read_word(colors + (i + (paquetes*500)));
            fragmentData(preData);

            mySerial->write(hd);
            mySerial->write(md);
            mySerial->write(ld);

          }

          mySerial->write(98);

        }//END if oneMore

      

        waitingData = true;
          while(waitingData){

            checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

            if(checked>0){
              if(bufferSerial[0] == 'c'){
                waitingData = false;
                txNotCompleted = false;
              }
            }

          }//END while waitingData
        
        //txNotCompleted = false;

      }//END else if 'g'

    }//END if checked
  }//END whiles txNotCompleted
}//END drawImage


void AndroidDisplay::invertDisplay(boolean i){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){
    mySerial->write(97);
    mySerial->write(20);

    if(i)  mySerial->write(29);  //TRUE
    else  mySerial->write(19);   //FALSE

    mySerial->write(98);

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}

void AndroidDisplay::setAddrWindow(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){
  mySerial->write(97);
  mySerial->write(21);

  fragmentData(x0);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y0);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(x1);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y1);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::setAddrWindowRect(uint16_t x, uint16_t y, uint16_t w, uint16_t h){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(22);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(w);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(h);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}

void AndroidDisplay::pushColor(uint16_t color){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(23);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::pushColors(const uint16_t *colors, uint16_t offset, uint32_t len){

  boolean oneMore = false;
  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){
  mySerial->write(97);
  mySerial->write(24);

  fragmentData(offset);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(len,0);

  mySerial->write(hd32);
  mySerial->write(md32);
  mySerial->write(ld32);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  float tempLimit = len - offset;
  uint16_t preData = 0;

  float tempPaquetes = (tempLimit / 500);
  int paquetes = round(tempPaquetes);
  float diferencia = 0;

  int ultimoPaquete = 0;


    if(paquetes > tempPaquetes){

      oneMore = true;
      paquetes -= 1;
      diferencia = tempPaquetes - paquetes;//paquetes - tempPaquetes;
      ultimoPaquete = (diferencia * 500);
    }

    else if(paquetes < tempPaquetes){

      oneMore = true;
      diferencia = tempPaquetes - paquetes;
      ultimoPaquete = (diferencia * 500);
    }


  int currentPackage = 0;

    if(tempPaquetes > 1){
      for(int i = 0; i<500; i++){
         preData = pgm_read_word(colors + (i) + offset);
         fragmentData(preData);

        mySerial->write(hd);
        mySerial->write(md);
        mySerial->write(ld);
        currentPackage = 1;
      }

    }

    else{
      for(int i = offset; i<len; i++){
         preData = pgm_read_word(colors + (i));
         fragmentData(preData);

        mySerial->write(hd);
        mySerial->write(md);
        mySerial->write(ld);
      }
    }


  mySerial->write(98);

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }

      else if(bufferSerial[0] == 'g'){
        boolean notFinished = true;
        boolean waitingData = true;

        for(int i = currentPackage; i<paquetes; i++){
          mySerial->write(97);
          mySerial->write(24);

          if((oneMore == false) && (i == (paquetes-1))){
            mySerial->write('i');//6=normal 9=finished
          }

          else{
            mySerial->write('h');//6=normal 9=finished
          }

      
          int tempJ = (i*500);

          for(int j=0; j<500; j++) {
            preData = pgm_read_word(colors + (j + tempJ) + offset);
            fragmentData(preData);

            mySerial->write(hd);
            mySerial->write(md);
            mySerial->write(ld);

          }

          mySerial->write(98);

          waitingData = true;

          while(waitingData){
            checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

            if(checked>0){
              if(bufferSerial[0] == 'g'){
                waitingData = false;
              }

              else if(bufferSerial[0] == 'c'){
                waitingData = false;
                txNotCompleted = false;
              }
            }

          }//END while waitingData
        }//END for

        if(oneMore){

          mySerial->write(97);
          mySerial->write(24);
          mySerial->write('i');//h=normal i=finished


          for(int i=0; i<ultimoPaquete; i++) {
            preData = pgm_read_word(colors + (i + (paquetes*500))+ offset);
            fragmentData(preData);

            mySerial->write(hd);
            mySerial->write(md);
            mySerial->write(ld);

          }

          mySerial->write(98);

        }//END if oneMore

      

        waitingData = true;
          while(waitingData){

            checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

            if(checked>0){
              if(bufferSerial[0] == 'c'){
                waitingData = false;
                txNotCompleted = false;
              }
            }

          }//END while waitingData
        

      }//END else if 'g'

    }//END if checked
  }//END whiles txNotCompleted
}//END pushColors


void AndroidDisplay::pushColors(uint16_t *colors, uint16_t offset, uint32_t len){

  boolean oneMore = false;
  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){
  mySerial->write(97);
  mySerial->write(25);

  fragmentData(offset);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(len,0);

  mySerial->write(hd32);
  mySerial->write(md32);
  mySerial->write(ld32);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  float tempLimit = len - offset;
  uint16_t preData = 0;

  float tempPaquetes = (tempLimit / 500);
  int paquetes = round(tempPaquetes);
  float diferencia = 0;

  int ultimoPaquete = 0;


    if(paquetes > tempPaquetes){

      oneMore = true;
      paquetes -= 1;
      diferencia = tempPaquetes - paquetes;//paquetes - tempPaquetes;
      ultimoPaquete = (diferencia * 500);
    }

    else if(paquetes < tempPaquetes){

      oneMore = true;
      diferencia = tempPaquetes - paquetes;
      ultimoPaquete = (diferencia * 500);
    }


  int currentPackage = 0;

    if(tempPaquetes > 1){
      for(int i = 0; i<500; i++){
         preData = *(colors + (i) + offset);
         fragmentData(preData);

        mySerial->write(hd);
        mySerial->write(md);
        mySerial->write(ld);
        currentPackage = 1;
      }

    }

    else{
      for(int i = offset; i<len; i++){
         preData = *(colors + (i));
         fragmentData(preData);

        mySerial->write(hd);
        mySerial->write(md);
        mySerial->write(ld);
      }
    }


  mySerial->write(98);

    checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }

      else if(bufferSerial[0] == 'g'){
        boolean notFinished = true;
        boolean waitingData = true;

        for(int i = currentPackage; i<paquetes; i++){
          mySerial->write(97);
          mySerial->write(25);

          if((oneMore == false) && (i == (paquetes-1))){
            mySerial->write('i');//6=normal 9=finished
          }

          else{
            mySerial->write('h');//6=normal 9=finished
          }

      
          int tempJ = (i*500);

          for(int j=0; j<500; j++) {
            preData = *(colors + (j + tempJ) + offset);
            fragmentData(preData);

            mySerial->write(hd);
            mySerial->write(md);
            mySerial->write(ld);

          }

          mySerial->write(98);

          waitingData = true;

          while(waitingData){
            checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

            if(checked>0){
              if(bufferSerial[0] == 'g'){
                waitingData = false;
              }

              else if(bufferSerial[0] == 'c'){
                waitingData = false;
                txNotCompleted = false;
              }
            }

          }//END while waitingData
        }//END for

        if(oneMore){

          mySerial->write(97);
          mySerial->write(25);
          mySerial->write('i');//h=normal i=finished


          for(int i=0; i<ultimoPaquete; i++) {
            preData = *(colors + (i + (paquetes*500))+ offset);
            fragmentData(preData);

            mySerial->write(hd);
            mySerial->write(md);
            mySerial->write(ld);

          }

          mySerial->write(98);

        }//END if oneMore

      

        waitingData = true;
          while(waitingData){

            checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

            if(checked>0){
              if(bufferSerial[0] == 'c'){
                waitingData = false;
                txNotCompleted = false;
              }
            }

          }//END while waitingData
        

      }//END else if 'g'

    }//END if checked
  }//END whiles txNotCompleted

}

void AndroidDisplay::setRotation(iliRotation r){
  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){
  mySerial->write(97);
  mySerial->write(26);

  fragmentData(r, false);

  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}//END setRotation


void AndroidDisplay::display(boolean d){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){
  mySerial->write(97);
  mySerial->write(27);

  if(d)  mySerial->write(29);  //TRUE
  else  mySerial->write(19);   //FALSE

  mySerial->write(98);
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::idle(boolean i){
  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){
  mySerial->write(97);
  mySerial->write(28);

  if(i)  mySerial->write(29);  //TRUE
  else  mySerial->write(19);   //FALSE

  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}

void AndroidDisplay::setAngleOffset(int16_t angleOffset){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(29);

  fragmentData(angleOffset);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }

}


void AndroidDisplay::setArcParams(float arcAngleMax){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(30);

  fragmentData(10*arcAngleMax);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}

void AndroidDisplay::setTextArea(gTextArea area){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(31);

  fragmentData(area.x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(area.y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(area.w);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(area.h);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::setTextArea(int16_t x, int16_t y, int16_t w, int16_t h){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){
  mySerial->write(97);
  mySerial->write(32);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(w);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(h);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}



void AndroidDisplay::setTextArea(int16_t x, int16_t y, int16_t columns, int16_t rows, uint8_t font){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(33);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(columns);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(rows);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);


  fragmentData(font, false);

  mySerial->write(md);
  mySerial->write(ld);


  mySerial->write(98);
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}



void AndroidDisplay::clearTextArea(){
  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){
  mySerial->write(97);
  mySerial->write(34);

  mySerial->write(98);
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}



void AndroidDisplay::clearTextArea(gTextArea area){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){
  mySerial->write(97);
  mySerial->write(35);

  fragmentData(area.x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(area.y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(area.w);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(area.h);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::clearTextArea(uint16_t color){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){
  mySerial->write(97);
  mySerial->write(36);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);


  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::clearTextArea(gTextArea area, uint16_t color){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){
  mySerial->write(97);
  mySerial->write(37);

  fragmentData(area.x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(area.y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(area.w);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(area.h);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);


  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::setFont(uint8_t font){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){
  mySerial->write(97);
  mySerial->write(38);

  fragmentData(font, false);

  mySerial->write(md);
  mySerial->write(ld);


  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::setTextColor(uint16_t color){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){
  mySerial->write(97);
  mySerial->write(39);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::setTextColor(uint8_t R, uint8_t G, uint8_t B){

checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(40);

  fragmentData(R, false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(G, false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(B, false);

  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::setTextColor(uint16_t color, uint16_t backgroundColor){

checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){


  mySerial->write(97);
  mySerial->write(41);

  fragmentData(color);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);


  fragmentData(backgroundColor);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::setTextColor(uint8_t R, uint8_t G, uint8_t B, uint8_t bgR, uint8_t bgG, uint8_t bgB){
  
  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(42);

  fragmentData(R, false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(G, false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(B, false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(bgR, false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(bgG, false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(bgB, false);

  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}

void AndroidDisplay::setTextLetterSpacing(uint8_t letterSpacing){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(43);

  fragmentData(letterSpacing, false);

  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::setTextLineSpacing(uint8_t lineSpacing){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(44);

  fragmentData(lineSpacing, false);

  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::setFontMode(gTextFontMode fontMode){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){
  mySerial->write(97);
  mySerial->write(45);

  fragmentData(fontMode, false);

  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::setTextScale(uint8_t textScale){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(46);

  fragmentData(textScale, false);

  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::cursorToXY(int16_t x, int16_t y){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(47);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);


  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::cursorTo(uint8_t column, uint8_t row){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(48);

  fragmentData(column, false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(row, false);

  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::cursorTo(uint8_t column){

checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(49);

  fragmentData(column, false);

  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::printAt(const char *str, int16_t x, int16_t y){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0;
  int strSum = 0;

  while (*str + sizeText)
  {
    //str++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(50);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  while (*str)
  {
    fragmentData(((uint8_t)*str),false);

    mySerial->write(md);
    mySerial->write(ld);

    str++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::printAt(const String &str, int16_t x, int16_t y){
  checked = 0;
  txNotCompleted = true;
  

  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(51);

  fragmentData(str.length());

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  for (uint16_t i = 0; i < str.length(); i++)
  {
    fragmentData(((uint8_t)str[i]),false);

    mySerial->write(md);
    mySerial->write(ld);

    
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }  
}


void AndroidDisplay::printAt(const __FlashStringHelper* str, int16_t x, int16_t y){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0; 
  PGM_P p = reinterpret_cast<PGM_P>(str);
  
  while (pgm_read_byte(p) != 0) {
    p++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(52);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  p = reinterpret_cast<PGM_P>(str);
  
  uint8_t c;
  while ((c = pgm_read_byte(p)) != 0) {
    fragmentData(c,false);

    mySerial->write(md);
    mySerial->write(ld);
    
    p++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }   
}

void AndroidDisplay::printAt(int num, int16_t x, int16_t y){
  String tempPri = String(num);
  printAt(tempPri,x,y);
}

void AndroidDisplay::printAt(float num, int16_t x, int16_t y){
  String tempPri = String(num);
  printAt(tempPri,x,y);
}

void AndroidDisplay::printAt(double num, int16_t x, int16_t y){
  String tempPri = String(num);
  printAt(tempPri,x,y);
}

void AndroidDisplay::printAt(const char *str, int16_t x, int16_t y, gTextEraseLine eraseLine){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0;
  int strSum = 0;

  while (*str + sizeText)
  {
    //str++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(53);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);


  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);


  fragmentData(eraseLine, false);

  mySerial->write(md);
  mySerial->write(ld);


  while (*str)
  {
    fragmentData(((uint8_t)*str),false);

    mySerial->write(md);
    mySerial->write(ld);

    str++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }  
}


void AndroidDisplay::printAt(const String &str, int16_t x, int16_t y, gTextEraseLine eraseLine){
   checked = 0;
  txNotCompleted = true;
  

  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(54);

  fragmentData(str.length());

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);


  fragmentData(eraseLine, false);

  mySerial->write(md);
  mySerial->write(ld);

  for (uint16_t i = 0; i < str.length(); i++)
  {
    fragmentData(((uint8_t)str[i]),false);

    mySerial->write(md);
    mySerial->write(ld);

    
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }  
}


void AndroidDisplay::printAt(const __FlashStringHelper *str, int16_t x, int16_t y, gTextEraseLine eraseLine){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0; 
  PGM_P p = reinterpret_cast<PGM_P>(str);
  
  while (pgm_read_byte(p) != 0) {
    p++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(55);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);


  fragmentData(eraseLine, false);

  mySerial->write(md);
  mySerial->write(ld);

  p = reinterpret_cast<PGM_P>(str);
  
  uint8_t c;
  while ((c = pgm_read_byte(p)) != 0) {
    fragmentData(c,false);

    mySerial->write(md);
    mySerial->write(ld);
    
    p++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  } 

}

void AndroidDisplay::printAt(int num, int16_t x, int16_t y, gTextEraseLine eraseLine){
  String tempPri = String(num);
  printAt(tempPri, x, y, eraseLine);
}

void AndroidDisplay::printAt(float num, int16_t x, int16_t y, gTextEraseLine eraseLine){
  String tempPri = String(num);
  printAt(tempPri, x, y, eraseLine);
}

void AndroidDisplay::printAt(double num, int16_t x, int16_t y, gTextEraseLine eraseLine){
  String tempPri = String(num);
  printAt(tempPri, x, y, eraseLine);
}

void AndroidDisplay::printAt(const char *str, int16_t x, int16_t y, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0;
  int strSum = 0;

  while (*str + sizeText)
  {
    //str++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(56);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);


  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnLeft);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnRight);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  while (*str)
  {
    fragmentData(((uint8_t)*str),false);

    mySerial->write(md);
    mySerial->write(ld);

    str++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::printAt(const String &str, int16_t x, int16_t y, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
 checked = 0;
  txNotCompleted = true;
  

  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(57);

  fragmentData(str.length());

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnLeft);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnRight);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  for (uint16_t i = 0; i < str.length(); i++)
  {
    fragmentData(((uint8_t)str[i]),false);

    mySerial->write(md);
    mySerial->write(ld);

    
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::printAt(const __FlashStringHelper *str, int16_t x, int16_t y, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0; 
  PGM_P p = reinterpret_cast<PGM_P>(str);
  
  while (pgm_read_byte(p) != 0) {
    p++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(58);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnLeft);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnRight);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  p = reinterpret_cast<PGM_P>(str);
  
  uint8_t c;
  while ((c = pgm_read_byte(p)) != 0) {
    fragmentData(c,false);

    mySerial->write(md);
    mySerial->write(ld);
    
    p++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}

void AndroidDisplay::printAt(int num, int16_t x, int16_t y, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  String tempPri = String(num);
  printAt(tempPri, x, y, pixelsClearedOnLeft, pixelsClearedOnRight);
}

void AndroidDisplay::printAt(float num, int16_t x, int16_t y, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  String tempPri = String(num);
  printAt(tempPri, x, y, pixelsClearedOnLeft, pixelsClearedOnRight);
}

void AndroidDisplay::printAt(double num, int16_t x, int16_t y, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  String tempPri = String(num);
  printAt(tempPri, x, y, pixelsClearedOnLeft, pixelsClearedOnRight);
}

void AndroidDisplay::printAtPivoted(const char *str, int16_t x, int16_t y, gTextPivot pivot){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0;
  int strSum = 0;

  while (*str + sizeText)
  {
    //str++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(59);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);


  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pivot,false);

  mySerial->write(md);
  mySerial->write(ld);

  while (*str)
  {
    fragmentData(((uint8_t)*str),false);

    mySerial->write(md);
    mySerial->write(ld);

    str++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }  

}


void AndroidDisplay::printAtPivoted(const String &str, int16_t x, int16_t y, gTextPivot pivot){
  checked = 0;
  txNotCompleted = true;
  

  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(60);

  fragmentData(str.length());

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pivot,false);

  mySerial->write(md);
  mySerial->write(ld);

  for (uint16_t i = 0; i < str.length(); i++)
  {
    fragmentData(((uint8_t)str[i]),false);

    mySerial->write(md);
    mySerial->write(ld);

    
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }   
}



void AndroidDisplay::printAtPivoted(const __FlashStringHelper *str, int16_t x, int16_t y, gTextPivot pivot){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0; 
  PGM_P p = reinterpret_cast<PGM_P>(str);
  
  while (pgm_read_byte(p) != 0) {
    p++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(61);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(x);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(y);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pivot,false);

  mySerial->write(md);
  mySerial->write(ld);

  p = reinterpret_cast<PGM_P>(str);
  
  uint8_t c;
  while ((c = pgm_read_byte(p)) != 0) {
    fragmentData(c,false);

    mySerial->write(md);
    mySerial->write(ld);
    
    p++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}

void AndroidDisplay::printAtPivoted(int num, int16_t x, int16_t y, gTextPivot pivot){
  String tempPri = String(num);
  printAtPivoted(tempPri, x, y, pivot);
}

void AndroidDisplay::printAtPivoted(double num, int16_t x, int16_t y, gTextPivot pivot){
  String tempPri = String(num);
  printAtPivoted(tempPri, x, y, pivot);
}

void AndroidDisplay::printAtPivoted(float num, int16_t x, int16_t y, gTextPivot pivot){
  String tempPri = String(num);
  printAtPivoted(tempPri, x, y, pivot);
}

void AndroidDisplay::printAligned(const char *str, gTextAlign align){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0;
  int strSum = 0;

  while (*str + sizeText)
  {
    //str++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(62);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);


  mySerial->write(md);
  mySerial->write(ld);

  while (*str)
  {
    fragmentData(((uint8_t)*str),false);

    mySerial->write(md);
    mySerial->write(ld);

    str++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  } 

}


void AndroidDisplay::printAligned(const String &str, gTextAlign align){
  checked = 0;
  txNotCompleted = true;
  

  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(63);

  fragmentData(str.length());

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  for (uint16_t i = 0; i < str.length(); i++)
  {
    fragmentData(((uint8_t)str[i]),false);

    mySerial->write(md);
    mySerial->write(ld);

    
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }

}


void AndroidDisplay::printAligned(const __FlashStringHelper *str, gTextAlign align){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0; 
  PGM_P p = reinterpret_cast<PGM_P>(str);
  
  while (pgm_read_byte(p) != 0) {
    p++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(64);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);


  mySerial->write(md);
  mySerial->write(ld);

  p = reinterpret_cast<PGM_P>(str);
  
  uint8_t c;
  while ((c = pgm_read_byte(p)) != 0) {
    fragmentData(c,false);

    mySerial->write(md);
    mySerial->write(ld);
    
    p++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  } 
}

void AndroidDisplay::printAligned(int num, gTextAlign align){
  String tempPri = String(num);
  printAligned(tempPri,align);
}

void AndroidDisplay::printAligned(float num, gTextAlign align){
  String tempPri = String(num);
  printAligned(tempPri,align);
}

void AndroidDisplay::printAligned(double num, gTextAlign align){
  String tempPri = String(num);
  printAligned(tempPri,align);
}

void AndroidDisplay::printAligned(const char *str, gTextAlign align, gTextEraseLine eraseLine){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0;
  int strSum = 0;

  while (*str + sizeText)
  {
    //str++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(65);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);


  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(eraseLine,false);


  mySerial->write(md);
  mySerial->write(ld);

  while (*str)
  {
    fragmentData(((uint8_t)*str),false);

    mySerial->write(md);
    mySerial->write(ld);

    str++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  } 
}


void AndroidDisplay::printAligned(const String &str, gTextAlign align, gTextEraseLine eraseLine){
  checked = 0;
  txNotCompleted = true;
  

  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(66);

  fragmentData(str.length());

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);


  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(eraseLine,false);


  mySerial->write(md);
  mySerial->write(ld);

  for (uint16_t i = 0; i < str.length(); i++)
  {
    fragmentData(((uint8_t)str[i]),false);

    mySerial->write(md);
    mySerial->write(ld);

    
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  } 
}



void AndroidDisplay::printAligned(const __FlashStringHelper *str, gTextAlign align, gTextEraseLine eraseLine){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0; 
  PGM_P p = reinterpret_cast<PGM_P>(str);
  
  while (pgm_read_byte(p) != 0) {
    p++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(67);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);


  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(eraseLine,false);


  mySerial->write(md);
  mySerial->write(ld);

  p = reinterpret_cast<PGM_P>(str);
  
  uint8_t c;
  while ((c = pgm_read_byte(p)) != 0) {
    fragmentData(c,false);

    mySerial->write(md);
    mySerial->write(ld);
    
    p++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}

void AndroidDisplay::printAligned(int num, gTextAlign align, gTextEraseLine eraseLine){
  String tempPri = String(num);
  printAligned(tempPri,align,eraseLine);
}

void AndroidDisplay::printAligned(float num, gTextAlign align, gTextEraseLine eraseLine){
  String tempPri = String(num);
  printAligned(tempPri,align,eraseLine);
}

void AndroidDisplay::printAligned(double num, gTextAlign align, gTextEraseLine eraseLine){
  String tempPri = String(num);
  printAligned(tempPri,align,eraseLine);
}

void AndroidDisplay::printAligned(const char *str, gTextAlign align, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0;
  int strSum = 0;

  while (*str + sizeText)
  {
    //str++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(68);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnLeft);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnRight);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  while (*str)
  {
    fragmentData(((uint8_t)*str),false);

    mySerial->write(md);
    mySerial->write(ld);

    str++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }  
}


void AndroidDisplay::printAligned(const String &str, gTextAlign align, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  checked = 0;
  txNotCompleted = true;
  

  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(69);

  fragmentData(str.length());

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnLeft);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnRight);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  for (uint16_t i = 0; i < str.length(); i++)
  {
    fragmentData(((uint8_t)str[i]),false);

    mySerial->write(md);
    mySerial->write(ld);

    
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::printAligned(const __FlashStringHelper *str, gTextAlign align, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0; 
  PGM_P p = reinterpret_cast<PGM_P>(str);
  
  while (pgm_read_byte(p) != 0) {
    p++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(70);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnLeft);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnRight);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  p = reinterpret_cast<PGM_P>(str);
  
  uint8_t c;
  while ((c = pgm_read_byte(p)) != 0) {
    fragmentData(c,false);

    mySerial->write(md);
    mySerial->write(ld);
    
    p++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}

void AndroidDisplay::printAligned(int num, gTextAlign align, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  String tempPri = String(num);
  printAligned(tempPri, align, pixelsClearedOnLeft, pixelsClearedOnRight);
}

void AndroidDisplay::printAligned(float num, gTextAlign align, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  String tempPri = String(num);
  printAligned(tempPri, align, pixelsClearedOnLeft, pixelsClearedOnRight);
}

void AndroidDisplay::printAligned(double num, gTextAlign align, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  String tempPri = String(num);
  printAligned(tempPri, align, pixelsClearedOnLeft, pixelsClearedOnRight);
}


void AndroidDisplay::printAlignedOffseted(const char *str, gTextAlign align, uint16_t offsetX, uint16_t offsetY){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0;
  int strSum = 0;

  while (*str + sizeText)
  {
    //str++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(71);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetX);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetY);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  while (*str)
  {
    fragmentData(((uint8_t)*str),false);

    mySerial->write(md);
    mySerial->write(ld);

    str++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }  
}



void AndroidDisplay::printAlignedOffseted(const String &str, gTextAlign align, uint16_t offsetX, uint16_t offsetY){
  checked = 0;
  txNotCompleted = true;
  

  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(72);

  fragmentData(str.length());

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetX);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetY);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  for (uint16_t i = 0; i < str.length(); i++)
  {
    fragmentData(((uint8_t)str[i]),false);

    mySerial->write(md);
    mySerial->write(ld);

    
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }  
}



void AndroidDisplay::printAlignedOffseted(const __FlashStringHelper *str, gTextAlign align, uint16_t offsetX, uint16_t offsetY){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0; 
  PGM_P p = reinterpret_cast<PGM_P>(str);
  
  while (pgm_read_byte(p) != 0) {
    p++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(73);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetX);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetY);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  p = reinterpret_cast<PGM_P>(str);
  
  uint8_t c;
  while ((c = pgm_read_byte(p)) != 0) {
    fragmentData(c,false);

    mySerial->write(md);
    mySerial->write(ld);
    
    p++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}

void AndroidDisplay::printAlignedOffseted(int num, gTextAlign align, uint16_t offsetX, uint16_t offsetY){
  String tempPri = String(num);
  printAlignedOffseted(tempPri, align,offsetX, offsetY);
}

void AndroidDisplay::printAlignedOffseted(float num, gTextAlign align, uint16_t offsetX, uint16_t offsetY){
  String tempPri = String(num);
  printAlignedOffseted(tempPri, align,offsetX, offsetY);
}

void AndroidDisplay::printAlignedOffseted(double num, gTextAlign align, uint16_t offsetX, uint16_t offsetY){
  String tempPri = String(num);
  printAlignedOffseted(tempPri, align,offsetX, offsetY);
}


void AndroidDisplay::printAlignedOffseted(const char *str, gTextAlign align, uint16_t offsetX, uint16_t offsetY, gTextEraseLine eraseLine){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0;
  int strSum = 0;

  while (*str + sizeText)
  {
    //str++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(74);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetX);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetY);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(eraseLine,false);

  mySerial->write(md);
  mySerial->write(ld);

  while (*str)
  {
    fragmentData(((uint8_t)*str),false);

    mySerial->write(md);
    mySerial->write(ld);

    str++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  } 
}


void AndroidDisplay::printAlignedOffseted(const String &str, gTextAlign align, uint16_t offsetX, uint16_t offsetY, gTextEraseLine eraseLine){
  checked = 0;
  txNotCompleted = true;
  

  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(75);

  fragmentData(str.length());

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetX);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetY);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(eraseLine,false);

  mySerial->write(md);
  mySerial->write(ld);

  for (uint16_t i = 0; i < str.length(); i++)
  {
    fragmentData(((uint8_t)str[i]),false);

    mySerial->write(md);
    mySerial->write(ld);

    
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  } 
}


void AndroidDisplay::printAlignedOffseted(const __FlashStringHelper *str, gTextAlign align, uint16_t offsetX, uint16_t offsetY, gTextEraseLine eraseLine){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0; 
  PGM_P p = reinterpret_cast<PGM_P>(str);
  
  while (pgm_read_byte(p) != 0) {
    p++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(76);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetX);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetY);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(eraseLine,false);

  mySerial->write(md);
  mySerial->write(ld);  

  p = reinterpret_cast<PGM_P>(str);
  
  uint8_t c;
  while ((c = pgm_read_byte(p)) != 0) {
    fragmentData(c,false);

    mySerial->write(md);
    mySerial->write(ld);
    
    p++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  } 
}

void AndroidDisplay::printAlignedOffseted(int num, gTextAlign align, uint16_t offsetX, uint16_t offsetY, gTextEraseLine eraseLine){
  String tempPri = String(num);
  printAlignedOffseted(tempPri, align, offsetX, offsetY, eraseLine);
}

void AndroidDisplay::printAlignedOffseted(float num, gTextAlign align, uint16_t offsetX, uint16_t offsetY, gTextEraseLine eraseLine){
  String tempPri = String(num);
  printAlignedOffseted(tempPri, align, offsetX, offsetY, eraseLine);
}

void AndroidDisplay::printAlignedOffseted(double num, gTextAlign align, uint16_t offsetX, uint16_t offsetY, gTextEraseLine eraseLine){
  String tempPri = String(num);
  printAlignedOffseted(tempPri, align, offsetX, offsetY, eraseLine);
}

void AndroidDisplay::printAlignedOffseted(const char *str, gTextAlign align, uint16_t offsetX, uint16_t offsetY, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0;
  int strSum = 0;

  while (*str + sizeText)
  {
    //str++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(77);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetX);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetY);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnLeft);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnRight);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  while (*str)
  {
    fragmentData(((uint8_t)*str),false);

    mySerial->write(md);
    mySerial->write(ld);

    str++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
 
}


void AndroidDisplay::printAlignedOffseted(const String &str, gTextAlign align, uint16_t offsetX, uint16_t offsetY, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  checked = 0;
  txNotCompleted = true;
  

  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(78);

  fragmentData(str.length());

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetX);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetY);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnLeft);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnRight);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  for (uint16_t i = 0; i < str.length(); i++)
  {
    fragmentData(((uint8_t)str[i]),false);

    mySerial->write(md);
    mySerial->write(ld);

    
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }  
}



void AndroidDisplay::printAlignedOffseted(const __FlashStringHelper *str, gTextAlign align, uint16_t offsetX, uint16_t offsetY, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0; 
  PGM_P p = reinterpret_cast<PGM_P>(str);
  
  while (pgm_read_byte(p) != 0) {
    p++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(79);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetX);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetY);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnLeft);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnRight);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  p = reinterpret_cast<PGM_P>(str);
  
  uint8_t c;
  while ((c = pgm_read_byte(p)) != 0) {
    fragmentData(c,false);

    mySerial->write(md);
    mySerial->write(ld);
    
    p++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  } 
}

void AndroidDisplay::printAlignedOffseted(int num, gTextAlign align, uint16_t offsetX, uint16_t offsetY, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  String tempPri = String(num);
  printAlignedOffseted(tempPri, align, offsetX, offsetY, pixelsClearedOnLeft, pixelsClearedOnRight);
}

void AndroidDisplay::printAlignedOffseted(float num, gTextAlign align, uint16_t offsetX, uint16_t offsetY, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  String tempPri = String(num);
  printAlignedOffseted(tempPri, align, offsetX, offsetY, pixelsClearedOnLeft, pixelsClearedOnRight);
}

void AndroidDisplay::printAlignedOffseted(double num, gTextAlign align, uint16_t offsetX, uint16_t offsetY, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  String tempPri = String(num);
  printAlignedOffseted(tempPri, align, offsetX, offsetY, pixelsClearedOnLeft, pixelsClearedOnRight);
}


void AndroidDisplay::printAlignedPivotedOffseted(const char *str, gTextAlign align, gTextPivot pivot, uint16_t offsetX, uint16_t offsetY){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0;
  int strSum = 0;

  while (*str + sizeText)
  {
    //str++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(80);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pivot,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetX);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetY);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  while (*str)
  {
    fragmentData(((uint8_t)*str),false);

    mySerial->write(md);
    mySerial->write(ld);

    str++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}



void AndroidDisplay::printAlignedPivotedOffseted(const String &str, gTextAlign align, gTextPivot pivot, uint16_t offsetX, uint16_t offsetY){
  checked = 0;
  txNotCompleted = true;
  

  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(81);

  fragmentData(str.length());

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pivot,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetX);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetY);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  for (uint16_t i = 0; i < str.length(); i++)
  {
    fragmentData(((uint8_t)str[i]),false);

    mySerial->write(md);
    mySerial->write(ld);

    
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}



void AndroidDisplay::printAlignedPivotedOffseted(const __FlashStringHelper *str, gTextAlign align, gTextPivot pivot, uint16_t offsetX, uint16_t offsetY){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0; 
  PGM_P p = reinterpret_cast<PGM_P>(str);
  
  while (pgm_read_byte(p) != 0) {
    p++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(82);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pivot,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetX);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetY);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  p = reinterpret_cast<PGM_P>(str);
  
  uint8_t c;
  while ((c = pgm_read_byte(p)) != 0) {
    fragmentData(c,false);

    mySerial->write(md);
    mySerial->write(ld);
    
    p++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}

void AndroidDisplay::printAlignedPivotedOffseted(int num, gTextAlign align, gTextPivot pivot, uint16_t offsetX, uint16_t offsetY){
  String tempPri = String(num);
  printAlignedPivotedOffseted(tempPri, align, pivot, offsetX, offsetY);
}

void AndroidDisplay::printAlignedPivotedOffseted(float num, gTextAlign align, gTextPivot pivot, uint16_t offsetX, uint16_t offsetY){
  String tempPri = String(num);
  printAlignedPivotedOffseted(tempPri, align, pivot, offsetX, offsetY);
}

void AndroidDisplay::printAlignedPivotedOffseted(double num, gTextAlign align, gTextPivot pivot, uint16_t offsetX, uint16_t offsetY){
  String tempPri = String(num);
  printAlignedPivotedOffseted(tempPri, align, pivot, offsetX, offsetY);
}

void AndroidDisplay::printAlignedPivotedOffseted(const char *str, gTextAlign align, gTextPivot pivot, uint16_t offsetX, uint16_t offsetY, gTextEraseLine eraseLine){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0;
  int strSum = 0;

  while (*str + sizeText)
  {
    //str++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(83);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pivot,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetX);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetY);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);  

  fragmentData(eraseLine,false);

  mySerial->write(md);
  mySerial->write(ld);

  while (*str)
  {
    fragmentData(((uint8_t)*str),false);

    mySerial->write(md);
    mySerial->write(ld);

    str++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}


void AndroidDisplay::printAlignedPivotedOffseted(const String &str, gTextAlign align, gTextPivot pivot, uint16_t offsetX, uint16_t offsetY, gTextEraseLine eraseLine){
  checked = 0;
  txNotCompleted = true;
  

  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(84);

  fragmentData(str.length());

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pivot,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetX);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetY);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);  

  fragmentData(eraseLine,false);

  mySerial->write(md);
  mySerial->write(ld);

  for (uint16_t i = 0; i < str.length(); i++)
  {
    fragmentData(((uint8_t)str[i]),false);

    mySerial->write(md);
    mySerial->write(ld);

    
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }  
}




void AndroidDisplay::printAlignedPivotedOffseted(const __FlashStringHelper *str, gTextAlign align, gTextPivot pivot, uint16_t offsetX, uint16_t offsetY, gTextEraseLine eraseLine){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0; 
  PGM_P p = reinterpret_cast<PGM_P>(str);
  
  while (pgm_read_byte(p) != 0) {
    p++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(85);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pivot,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetX);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetY);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);  

  fragmentData(eraseLine,false);

  mySerial->write(md);
  mySerial->write(ld);

  p = reinterpret_cast<PGM_P>(str);
  
  uint8_t c;
  while ((c = pgm_read_byte(p)) != 0) {
    fragmentData(c,false);

    mySerial->write(md);
    mySerial->write(ld);
    
    p++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }  
}

void AndroidDisplay::printAlignedPivotedOffseted(int num, gTextAlign align, gTextPivot pivot, uint16_t offsetX, uint16_t offsetY, gTextEraseLine eraseLine){
  String tempPri = String(num);
  printAlignedPivotedOffseted(tempPri, align, pivot, offsetX, offsetY, eraseLine);
}

void AndroidDisplay::printAlignedPivotedOffseted(float num, gTextAlign align, gTextPivot pivot, uint16_t offsetX, uint16_t offsetY, gTextEraseLine eraseLine){
  String tempPri = String(num);
  printAlignedPivotedOffseted(tempPri, align, pivot, offsetX, offsetY, eraseLine);
}

void AndroidDisplay::printAlignedPivotedOffseted(double num, gTextAlign align, gTextPivot pivot, uint16_t offsetX, uint16_t offsetY, gTextEraseLine eraseLine){
  String tempPri = String(num);
  printAlignedPivotedOffseted(tempPri, align, pivot, offsetX, offsetY, eraseLine);
}

void AndroidDisplay::printAlignedPivotedOffseted(const char *str, gTextAlign align, gTextPivot pivot, uint16_t offsetX, uint16_t offsetY, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  //86
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0;
  int strSum = 0;

  while (*str + sizeText)
  {
    //str++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(86);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pivot,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetX);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetY);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnLeft);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnRight);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  while (*str)
  {
    fragmentData(((uint8_t)*str),false);

    mySerial->write(md);
    mySerial->write(ld);

    str++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  } 
}




void AndroidDisplay::printAlignedPivotedOffseted(const String &str, gTextAlign align, gTextPivot pivot, uint16_t offsetX, uint16_t offsetY, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  //87
  checked = 0;
  txNotCompleted = true;
  

  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(87);

  fragmentData(str.length());

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pivot,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetX);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetY);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnLeft);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnRight);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  for (uint16_t i = 0; i < str.length(); i++)
  {
    fragmentData(((uint8_t)str[i]),false);

    mySerial->write(md);
    mySerial->write(ld);

    
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}




void AndroidDisplay::printAlignedPivotedOffseted(const __FlashStringHelper *str, gTextAlign align, gTextPivot pivot, uint16_t offsetX, uint16_t offsetY, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  //88
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0; 
  PGM_P p = reinterpret_cast<PGM_P>(str);
  
  while (pgm_read_byte(p) != 0) {
    p++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(88);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(align,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pivot,false);

  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetX);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(offsetY);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnLeft);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  fragmentData(pixelsClearedOnRight);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  p = reinterpret_cast<PGM_P>(str);
  
  uint8_t c;
  while ((c = pgm_read_byte(p)) != 0) {
    fragmentData(c,false);

    mySerial->write(md);
    mySerial->write(ld);
    
    p++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }  
}

void AndroidDisplay::printAlignedPivotedOffseted(int num, gTextAlign align, gTextPivot pivot, uint16_t offsetX, uint16_t offsetY, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  String tempPri = String(num);
  printAlignedPivotedOffseted(tempPri, align, pivot, offsetX, offsetY, pixelsClearedOnLeft, pixelsClearedOnRight);
}

void AndroidDisplay::printAlignedPivotedOffseted(float num, gTextAlign align, gTextPivot pivot, uint16_t offsetX, uint16_t offsetY, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  String tempPri = String(num);
  printAlignedPivotedOffseted(tempPri, align, pivot, offsetX, offsetY, pixelsClearedOnLeft, pixelsClearedOnRight);
}

void AndroidDisplay::printAlignedPivotedOffseted(double num, gTextAlign align, gTextPivot pivot, uint16_t offsetX, uint16_t offsetY, uint16_t pixelsClearedOnLeft, uint16_t pixelsClearedOnRight){
  String tempPri = String(num);
  printAlignedPivotedOffseted(tempPri, align, pivot, offsetX, offsetY, pixelsClearedOnLeft, pixelsClearedOnRight);
}

void AndroidDisplay::print(const char *str){
    checked = 0;
  txNotCompleted = true;
  int sizeText = 0;
  int strSum = 0;

  while (*str + sizeText)
  {
    //str++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(89);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  while (*str)
  {
    fragmentData(((uint8_t)*str),false);

    mySerial->write(md);
    mySerial->write(ld);

    str++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }

}


void AndroidDisplay::print(const String &str){
  checked = 0;
  txNotCompleted = true;
  

  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(90);

  fragmentData(str.length());

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  for (uint16_t i = 0; i < str.length(); i++)
  {
    fragmentData(((uint8_t)str[i]),false);

    mySerial->write(md);
    mySerial->write(ld);

    
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }

}


void AndroidDisplay::print(const __FlashStringHelper* str){
  checked = 0;
  txNotCompleted = true;
  int sizeText = 0; 
  PGM_P p = reinterpret_cast<PGM_P>(str);
  
  while (pgm_read_byte(p) != 0) {
    p++;
    sizeText++;
  }


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(91);

  fragmentData(sizeText);

  mySerial->write(hd);
  mySerial->write(md);
  mySerial->write(ld);

  p = reinterpret_cast<PGM_P>(str);
  
  uint8_t c;
  while ((c = pgm_read_byte(p)) != 0) {
    fragmentData(c,false);

    mySerial->write(md);
    mySerial->write(ld);

    p++;
  }

  mySerial->write(98);

  
  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }

}

void AndroidDisplay::print(int num){
  String temp = String(num);
  print(temp);
}

void AndroidDisplay::print(float num){
  String temp = String(num);
  print(temp);
}

void AndroidDisplay::print(double num){
  String temp = String(num);
  print(temp);
}

void AndroidDisplay::print(long unsigned int num, int tipo){
  String tempPri = String(num,tipo);
  print(tempPri);
}

void AndroidDisplay::resetDisplay(){

  checked = 0;
  txNotCompleted = true;


  while(txNotCompleted){

  mySerial->write(97);
  mySerial->write(92);

  fragmentData(5, false);

  mySerial->write(md);
  mySerial->write(ld);

  mySerial->write(98);

  checked = mySerial->readBytesUntil(42, bufferSerial,sizeof(bufferSerial));

    if(checked>0){
      if(bufferSerial[0] == 'c'){
        txNotCompleted = false;
      }
    }
  }
}
