#include "AndroidDisplay.h"

AndroidDisplay tft;

long Screenfill,
  Text,
  Lines,
  HorizVertLines,
  Rectanglesoutline,
  Rectanglesfilled,
  Circlesfilled,
  Circlesoutline,
  Trianglesoutline,
  Trianglesfilled,
  Roundedrectsoutline,
  Roundedrectsfilled;

void setup() {
  // put your setup code here, to run once:
  Serial.begin(38400);//38400
  tft.setSerial(Serial);
  tft.setRotation(iliRotation0);
  tft.fillScreen(ILI9341_BLUE);
  
  tft.setFont(Arial_bold_14);
  tft.setTextLetterSpacing(2);
  tft.setTextColor(ILI9341_WHITE, ILI9341_BLACK);

  testFillScreen();
  delay(200);

  testText();
  delay(600);


  testLines(ILI9341_CYAN);
  delay(200);

  testFastLines(ILI9341_RED, ILI9341_BLUE);
  delay(200);

  testRects(ILI9341_GREEN);
  delay(200);

  testFilledRects(ILI9341_YELLOW, ILI9341_MAGENTA);
  delay(200);

  testFilledCircles(10, ILI9341_MAGENTA);

  testCircles(10, ILI9341_WHITE);
  delay(200);

  testTriangles();
  delay(200);

  testFilledTriangles();
  delay(200);

  testRoundRects();
  delay(200);

  testFilledRoundRects();
  delay(200);


}


void loop() {
 for(uint8_t rotation=0; rotation<4; rotation++) {
    tft.setRotation((iliRotation)rotation);
    testText();
    delay(1000);
  }
}

unsigned long testFillScreen() {
  unsigned long start = micros();
  tft.fillScreen(ILI9341_BLACK);
  tft.fillScreen(ILI9341_RED);
  tft.fillScreen(ILI9341_GREEN);
  tft.fillScreen(ILI9341_BLUE);
  tft.fillScreen(ILI9341_BLACK);
  return micros() - start;
}

unsigned long testText() {
  tft.fillScreen(ILI9341_BLACK);
  unsigned long start = micros();
  tft.cursorTo(0, 0);
  //tft.setFont(SystemFont5x7);
  tft.setTextColor(ILI9341_WHITE);  tft.setTextScale(1);
  tft.print("Hello World!\n");
  tft.setTextColor(ILI9341_YELLOW); tft.setTextScale(2);
 tft.print(1234.56);
 tft.setTextScale(1);
  tft.print("\n");
  tft.setTextColor(ILI9341_RED);    tft.setTextScale(3);
  tft.print(0xDEADBEEF,HEX);
  tft.print("\n");
  tft.setTextColor(ILI9341_GREEN);
  tft.setTextScale(3);//5
  tft.print("Groop");
  tft.setTextScale(1);//5
  tft.print("\n");
  tft.setTextScale(2);
  tft.print("I implore thee,");
  tft.setTextScale(1);
  tft.print("\n");
  tft.print("my foonting turlingdromes.\n");
  tft.print("And hooptiously drangle me\n");
  tft.print("with crinkly bindlewurdles,\n");
  tft.print("Or I will rend thee\n");
  tft.print("in the gobberwarts\n");
  tft.print("with my blurglecruncheon,\n");
  tft.print("see if I don't!\n");
  return micros() - start;
}

unsigned long testLines(uint16_t color) {
  unsigned long start, t;
  int           x1, y1, x2, y2,
                w = 240,
                h = 320;

  tft.fillScreen(ILI9341_BLACK);

  x1 = y1 = 0;
  y2    = h - 1;
  start = micros();
  for(x2=0; x2<w; x2+=6) tft.drawLine(x1, y1, x2, y2, color);
  x2    = w - 1;
  for(y2=0; y2<h; y2+=6) tft.drawLine(x1, y1, x2, y2, color);
  t     = micros() - start; // fillScreen doesn't count against timing

  tft.fillScreen(ILI9341_BLACK);

  x1    = w - 1;
  y1    = 0;
  y2    = h - 1;
  start = micros();
  for(x2=0; x2<w; x2+=6) tft.drawLine(x1, y1, x2, y2, color);
  x2    = 0;
  for(y2=0; y2<h; y2+=6) tft.drawLine(x1, y1, x2, y2, color);
  t    += micros() - start;

  tft.fillScreen(ILI9341_BLACK);

  x1    = 0;
  y1    = h - 1;
  y2    = 0;
  start = micros();
  for(x2=0; x2<w; x2+=6) tft.drawLine(x1, y1, x2, y2, color);
  x2    = w - 1;
  for(y2=0; y2<h; y2+=6) tft.drawLine(x1, y1, x2, y2, color);
  t    += micros() - start;

  tft.fillScreen(ILI9341_BLACK);

  x1    = w - 1;
  y1    = h - 1;
  y2    = 0;
  start = micros();
  for(x2=0; x2<w; x2+=6) tft.drawLine(x1, y1, x2, y2, color);
  x2    = 0;
  for(y2=0; y2<h; y2+=6) tft.drawLine(x1, y1, x2, y2, color);

  return micros() - start;
}

unsigned long testFastLines(uint16_t color1, uint16_t color2) {
  unsigned long start;
  int           x, y, w = 240, h = 320;

  tft.fillScreen(ILI9341_BLACK);
  start = micros();
  for(y=0; y<h; y+=5) tft.drawFastHLine(0, y, w, color1);
  for(x=0; x<w; x+=5) tft.drawFastVLine(x, 0, h, color2);

  return micros() - start;
}

unsigned long testRects(uint16_t color) {
  unsigned long start;
  int           n, i, i2,
                cx = 240  / 2,
                cy = 320 / 2;

  tft.fillScreen(ILI9341_BLACK);
  n     = min(240, 320);
  start = micros();
  for(i=2; i<n; i+=6) {
    i2 = i / 2;
    tft.drawRect(cx-i2, cy-i2, i, i, color);
  }

  return micros() - start;
}

unsigned long testFilledRects(uint16_t color1, uint16_t color2) {
  unsigned long start, t = 0;
  int           n, i, i2,
                cx = 240  / 2 - 1,
                cy = 320 / 2 - 1;

  tft.fillScreen(ILI9341_BLACK);
  n = min(240, 320);
  for(i=n; i>0; i-=6) {
    i2    = i / 2;
    start = micros();
    tft.fillRect(cx-i2, cy-i2, i, i, color1);
    t    += micros() - start;
    // Outlines are not included in timing results
    tft.drawRect(cx-i2, cy-i2, i, i, color2);
  }

  return t;
}

unsigned long testFilledCircles(uint8_t radius, uint16_t color) {
  unsigned long start;
  int x, y, w = 240, h = 320, r2 = radius * 2;

  tft.fillScreen(ILI9341_BLACK);
  start = micros();
  for(x=radius; x<w; x+=r2) {
    for(y=radius; y<h; y+=r2) {
      tft.fillCircle(x, y, radius, color);
    }
  }

  return micros() - start;
}

unsigned long testCircles(uint8_t radius, uint16_t color) {
  unsigned long start;
  int           x, y, r2 = radius * 2,
                w = 240  + radius,
                h = 320 + radius;

  // Screen is not cleared for this one -- this is
  // intentional and does not affect the reported time.
  start = micros();
  for(x=0; x<w; x+=r2) {
    for(y=0; y<h; y+=r2) {
      tft.drawCircle(x, y, radius, color);
    }
  }

  return micros() - start;
}

unsigned long testTriangles() {
  unsigned long start;
  int           n, i, cx = 240  / 2 - 1,
                      cy = 320 / 2 - 1;

  tft.fillScreen(ILI9341_BLACK);
  n     = min(cx, cy);
  start = micros();
  for(i=0; i<n; i+=5) {
    tft.drawTriangle(
      cx    , cy - i, // peak
      cx - i, cy + i, // bottom left
      cx + i, cy + i, // bottom right
      tft.color565(0, 0, i));
  }

  return micros() - start;
}

unsigned long testFilledTriangles() {
  unsigned long start, t = 0;
  int           i, cx = 240  / 2 - 1,
                   cy = 320 / 2 - 1;

  tft.fillScreen(ILI9341_BLACK);
  start = micros();
  for(i=min(cx,cy); i>10; i-=5) {
    start = micros();
    tft.fillTriangle(cx, cy - i, cx - i, cy + i, cx + i, cy + i,
      tft.color565(0, i, i));
    t += micros() - start;
    tft.drawTriangle(cx, cy - i, cx - i, cy + i, cx + i, cy + i,
      tft.color565(i, i, 0));
  }

  return t;
}

unsigned long testRoundRects() {
  unsigned long start;
  int           w, i, i2,
                cx = 240  / 2 - 1,
                cy = 320 / 2 - 1;

  tft.fillScreen(ILI9341_BLACK);
  w     = min(240, 320);
  start = micros();
  for(i=0; i<w; i+=6) {
    i2 = i / 2;
    tft.drawRoundRect(cx-i2, cy-i2, i, i, i/8, tft.color565(i, 0, 0));
  }

  return micros() - start;
}

unsigned long testFilledRoundRects() {
  unsigned long start;
  int           i, i2,
                cx = 240 / 2 - 1,
                cy = 320 / 2 - 1;

  tft.fillScreen(ILI9341_BLACK);
  start = micros();
  for(i=min(240, 320); i>20; i-=6) {
    i2 = i / 2;
    tft.fillRoundRect(cx-i2, cy-i2, i, i, i/8, tft.color565(0, i, 0));
  }

  return micros() - start;
}


